#include <iostream>
#include <algorithm>

using namespace std;

const int MaxInt = 32767;
int N;
int* V;

int leiaKogus(int S)
{
    if (S < 0) {
        return MaxInt;  //tagastame "lpmatuse"
    }
    if (S == 0) {
        return 0;
    }
    else {
        int vastus = MaxInt;

        for (int i = 0; i < N; i++) {
            vastus = min(vastus, 1 + leiaKogus(S - V[i]));
        }
        return vastus;
    }
}

int main()
{
    int S;
    cin >> S; //Summa
    cin >> N; //Mntide arv
    V = new int[N];
    for (int i = 0; i < N; i++){
        cin >> V[i]; //Mntide vrtused
    }
    cout << leiaKogus(S) << endl;
    return 0;
}

